package stack;
import java.util.*;

/**
* Classe che implementa una struttura LIFO.
* Non accetta elementi nulli.
*/
public class StackAL<T>
{
	private ArrayList<T> storage = new ArrayList<T>();

	/*
	public StackAL()
	{
	}
	*/

	/**
	* Metodo di inserimento.
	* Ritorna true in caso di successo, false in caso di fallimento.
	* Non accetta elementi null.
	*/
	public boolean push(T elem)
	{
		if(elem == null)
		{
			System.err.println("Null is not acceptable");
			return false;
		}
		if(isFull())
		{
			System.err.println("Stack full");
			return false;
		}

		storage.add(0, elem);
		return true;
	}

	/**
	* Metodo di lettura distruttiva.
	* Ritorna null in caso di stack vuoto.
	*/
	public T pop()
	{
		if(isEmpty())
		{
			System.err.println("Stack empty");
			return null;
		}
		return storage.remove(0);
	}

	/**
	* Metodo di interrogazione sul numero di elementi contenuti.
	*/
	public int size()
	{
		return storage.size();
	}

	/**
	* Metodo di interrogazione sulla condizione di stack vuoto.
	*/
	public boolean isEmpty()
	{
		return size() == 0;
	}

	/**
	* Metodo di interrogazione sulla condizione di stack pieno.
	*/
	public boolean isFull()
	{
		return false;
	}

	/**
	* Metodo per la rappresentazione stringa dello stack.
	*/
	public String toString()
	{
		return storage.toString();
	}
}
